unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, winsock;

type
  TForm1 = class(TForm)
    Button1: TButton;
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    procedure Button1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

//Requires Winsock 2 be installed. ie NT4.0 SP3 or IE 4.0 or better.

{$EXTERNALSYM WSAIoctl}
function WSAIoctl( hSocket: TSocket; ControlCode:dword;
                   InBuf : Pointer; InBufLen:DWord;
                   OutBuf : Pointer; OutBufLen:DWord;
                   BytesReturned : PDWord;
                   lpOverlapped: POverlapped;
                   lpOverlappedRoutine:pointer) : Integer; stdcall;
{$EXTERNALSYM WSASocket}
function WSASocket(Family, sType, Protocol : Integer;
                   lpProtocolInfo : Pointer;
                   Group : uint;
                   dwFlags : DWORD): TSocket; stdcall

function WSAIoctl;          external     'ws2_32.dll' name 'WSAIoctl';
function WSASocket;         external     'ws2_32.dll' name 'WSASocketA';


Type

  _INTERFACE_INFO = record
    iiFlags            : ulong;      //* Type and status of the interface */
    iiAddress          : TSockaddr;  //* Interface address */
    iiBroadcastAddress : TSockaddr;  //* Broadcast address */
    iiNetmask          : TSockaddr;  //* Network mask */
  end;

Const
 IFF_UP =		$00000001; //* Interface is up */
 IFF_BROADCAST =	$00000002; //* Broadcast is  supported */
 IFF_LOOPBACK = 	$00000004; //* this is loopback interface */
 IFF_POINTTOPOINT =     $00000008; //*this is point-to-point interface*/
 IFF_MULTICAST =	$00000010; //* multicast is supported */



implementation

{$R *.DFM}

function GetIPMaskKey : string;
  var
    OutBufLen,RecvBytes,i : DWORD;
    wsError :Integer;
    WSAData: TWSAData;
    MySocket : TSocket;
    localAddr : Array[1..10] of _INTERFACE_INFO; //up to 10 NICs
    pAddrInet : TSockAddr;
    pAddrString : String;
  const SIO_GET_INTERFACE_LIST :dword = 1074033791;

begin
  wsError := Winsock.WSAStartup(2,  WSAData); //winsock 2 or better.
  If wsError <> 0 then  exit;
  MySocket := WSASocket(AF_INET, Sock_DGRAM, IPPROTO_UDP, nil,0,0);
  If MySocket = INVALID_SOCKET then exit;
  OutBufLen := Sizeof(localAddr); RecvBytes := OutBufLen;
  FillChar(LocalAddr,OutBufLen,0);
  wsError := WSAIoctl(MySocket,SIO_GET_INTERFACE_LIST,nil,0,
                            @localAddr, OutBufLen, @RecvBytes,nil,nil);
  if wsError = SOCKET_ERROR then
  begin
    wsError := WSAGetLastError;
    ShowMessage('Socket error:'+IntToStr(wsError));
    exit;
  end;
  for i := 1 to RecvBytes div Sizeof(_Interface_Info) do
  begin
    Form1.ListBox1.items.add('Network Interface: '+IntToStr(i));
    pAddrInet := localAddr[i].iiAddress;
    pAddrString := inet_ntoa(pAddrInet.sin_addr );
    Form1.ListBox1.items.add('Address: '+pAddrString);

    pAddrInet := localAddr[i].iiBroadcastAddress;
    pAddrString := inet_ntoa(pAddrInet.sin_addr );
    Form1.ListBox1.items.add('Broadcast Address: '+pAddrString);

    pAddrInet := localAddr[i].iiNetMask;
    pAddrString := inet_ntoa(pAddrInet.sin_addr);
    Form1.ListBox1.items.add('Mask: '+pAddrString);

    If (localAddr[i].iiFlags and IFF_UP) >0 then
      Form1.ListBox1.items.add('Interface is Up');
    If (localAddr[i].iiFlags and IFF_Broadcast) >0 then
      Form1.ListBox1.items.add('Broadcasts are supported.');
    If (localAddr[i].iiFlags and IFF_Multicast) >0 then
      Form1.ListBox1.items.add('Multicasts are supported.');
    If (localAddr[i].iiFlags and IFF_Loopback) >0 then
      Form1.ListBox1.items.add('This is a loopback interface');
    If (localAddr[i].iiFlags and IFF_PointToPoint) >0 then
      Form1.ListBox1.items.add('This is a point-to-point interface');

    Form1.ListBox1.items.add(' '); //blank line
  end;
  closesocket(MySocket);
  WSACleanup();
end;

procedure GetHostInfo(var Name, Address: string);
var
  WSAData: TWSAData;
  HostEnt: PHostEnt;
begin
  { no error checking...}
  WSAStartup(2, WSAData);
  SetLength(Name, 255);
  Gethostname(PChar(Name), 255);
  SetLength(Name, StrLen(PChar(Name)));
  HostEnt := gethostbyname(PChar(Name));
  with HostEnt^  do
    Address := Format('%d.%d.%d.%d',[
      Byte(h_addr^[0]),
      Byte(h_addr^[1]),
      Byte(h_addr^[2]),
      Byte(h_addr^[3])]);
  WSACleanup;
end;


procedure TForm1.Button1Click(Sender: TObject);
var name,addr : string;
begin
  name := 'localhost';
  GetHostInfo(name,addr);
  Label2.Caption := addr;
  Listbox1.Items.Clear;
  GetIPMaskKey;
end;

end.
